#include "ToRegExp.h"
#include <registration/AlgoRegistration.hpp>

namespace {

auto ToRegExpRightRG = registration::AbstractRegister < grammar::convert::ToRegExp, regexp::UnboundedRegExp < >, const grammar::RightRG < > & > ( grammar::convert::ToRegExp::convert, "grammar" ).setDocumentation (
"Converts a regular grammar to regular expression.\n\
\n\
@param grammar the regular grammar to convert\n\
@return regexp describing language generated by @p grammar." );

auto ToRegExpLeftRG = registration::AbstractRegister < grammar::convert::ToRegExp, regexp::UnboundedRegExp < >, const grammar::LeftRG < > & > ( grammar::convert::ToRegExp::convert, "grammar" ).setDocumentation (
"Converts a regular grammar to regular expression.\n\
\n\
@param grammar the regular grammar to convert\n\
@return regexp describing language generated by @p grammar." );

} /* namespace */
